from datetime import datetime
from typing import List, Optional, Union

import sqlalchemy as sa
from fin_data.queries import find_new_entities_query
from sqlalchemy import DeclarativeMeta
from database_utils import get_engine


async def email_new_entities(
    sa_obj: Union[sa.Table, DeclarativeMeta],
    since_time: Union[datetime, str],
    sources: Optional[Union[List[str], str]] = None,
    max_html_rows: int = 1000,
    max_attachment_size_mb: int = 20,
    engine=None,
):
    engine = engine or get_engine()
    query = find_new_entities_query(
        sa_obj=sa_obj, since_time=since_time, count=False, sources=sources
    )
    async with engine.begin() as conn:
        entities = await conn.execute(query).fetchall()
    entities
