import pandas as pd
from dataclasses import dataclass

def return_on_risk():
    """
    The percentage of the mark compared to the potential loss of an option position.
    Since most spread types have defined risk that is equal to the buying power,
    this number will often be the same as "return on capital".
    Not annualized.
    Return on risk = max risk.
    """
    pass

def return_on_capital():
    """
    The percentage of the mark compared to the buying power of an option position.
    Since the buying power effect is capital that is made unavailable by the trade,
    the return on capital could be viewed as the amount of return expected on a sale of the position for cash.
    Not annualized.
    Return on capital = mark / margin req.

    dividing the operating income (i.e., the maximum potential return) of the trade by the value of invested capital.
    It will show the percentage return if the position is at maximum profit at expiration.
    If your position ends up losing money, or if you close the position early for less than max profit,
    you won't receive the stated return on capital. But when you do close out the trade,
    that same calculation—dividing the return (or loss) by the original investment amount—can tell you how your trade fared.
    """



def covered_return():
    """
    An annualized projected return of a covered position where options are sold for cash at the expense of limiting maximum gain on the underlying position.
    Covered return = call mark - in the money amount / stock price * 365/calendar days to expiration.
    """
    pass


def risk_reward_ratio(df):
    pass


def required_move_factor(df):
    # required move / days to expiration
    return (df.underlying_mark - df.strike_price) / df.days_to_expiration

def implied_time_value(df):
    return df.underlying_mark - df.strike_price - df.ask

# risking what to make what?

