import sqlalchemy as sa
from sqlalchemy import func
from sqlalchemy.dialects.postgresql import ARRAY, JSON
from sqlalchemy.ext.declarative import declarative_base

from company_data.entity import SaCompanyData
from company_data.const import SCHEMA_NAME


class LinkedInSalesNav(SaCompanyData):
    __table_args__ = {"schema": SCHEMA_NAME}
    __tablename__ = "linkedin_sales_nav"

    profile_url = sa.Column(sa.String, primary_key=True)
    name = sa.Column(sa.String)
    title = sa.Column(sa.String)
    company_name = sa.Column(sa.String)
    company_url = sa.Column(sa.String)
    location = sa.Column(sa.String)
    results_page_num = sa.Column(sa.Integer)
    search_params = JSON()
    created = sa.Column(sa.DateTime(timezone=True), default=func.now())

    updated = sa.Column(sa.DateTime(timezone=True), default=func.now())
