from distbot.spider import Spider
from html_text import extract_text
import psycopg2

from random import uniform
from pathlib import Path
import asyncio
import sys
import os


async def is_login_page(page):
    if "www.linkedin.com/sales/login" in page.url:
        return True
    un = await page.J('input[id="username"]')
    pw = await page.J('input[id="password"]')
    s = await page.J('button[type="submit"]')
    return un and pw and s


async def login(page):
    print("Logging in.")
    await page.type(
        'input[id="username"]', os.environ.get("LINKEDIN_EMAIL"), delay=uniform(5, 10)
    )
    await page.type(
        'input[id="password"]', os.environ.get("LINKEDIN_PASS"), delay=uniform(5, 10)
    )
    await asyncio.sleep(uniform(0.5, 1))
    submit_ele = await page.J('button[type="submit"]')
    await submit_ele.click(delay=uniform(5, 10))
    await asyncio.sleep(3)
    print("Login complete.")


async def fetch(spider, url, **spider_kwargs):
    _, page = await spider.get(url, **spider_kwargs)
    is_login = await is_login_page(page)
    if is_login:
        print("Detected login page.")
        await login(page)
    html = await page.content()
    text = extract_text(html)
    if "Let's do a quick security check" in text:
        input("SOLVE SECURITY CHECK")
    elif (
        "You’ve made too many requests in too short a time. Please try again later."
        in text
    ):
        print("TOO MANY REQUESTS! sleeping")
        await asyncio.sleep(60 * 11)
        return await fetch(spider, url, **spider_kwargs)
    return page


def get_sql_conn():
    return psycopg2.connect(
        dbname="linkedin",
        user=os.environ.get("PG_USER"),
        password=os.environ.get("PG_PASS"),
    )


async def get_spider():
    spider = Spider()
    for _ in range(1):
        await spider.add_browser(
            launch_options={
                "headless": False,
                "screenshot": False,
                "ignoreHTTPSErrors": True,
                "defaultViewport": {},
                "executablePath": "/usr/bin/google-chrome-stable",
                "defaultNavigationTimeout": 60_000,
                "maxConsecutiveError": 10,
                "args": [
                    "--disable-web-security",
                    "--no-sandbox",
                    "--start-maximized",
                    # "--blink-settings=imagesEnabled=false",
                ],
            }
        )
    return spider
