from time import sleep

import requests
from td_connect import TDAuth

fields = [
    "cusip",
    "symbol",
    "description",
    "exchange",
    "assetType",
    "searched_symbol",
    "high52",
    "low52",
    "dividendAmount",
    "dividendYield",
    "dividendDate",
    "peRatio",
    "pegRatio",
    "pbRatio",
    "prRatio",
    "pcfRatio",
    "grossMarginTTM",
    "grossMarginMRQ",
    "netProfitMarginTTM",
    "netProfitMarginMRQ",
    "operatingMarginTTM",
    "operatingMarginMRQ",
    "returnOnEquity",
    "returnOnAssets",
    "returnOnInvestment",
    "quickRatio",
    "currentRatio",
    "interestCoverage",
    "totalDebtToCapital",
    "ltDebtToEquity",
    "totalDebtToEquity",
    "epsTTM",
    "epsChangePercentTTM",
    "epsChangeYear",
    "epsChange",
    "revChangeYear",
    "revChangeTTM",
    "revChangeIn",
    "sharesOutstanding",
    "marketCapFloat",
    "marketCap",
    "bookValuePerShare",
    "shortIntToFloat",
    "shortIntDayToCover",
    "divGrowthRate3Year",
    "dividendPayAmount",
    "dividendPayDate",
    "beta",
    "vol1DayAvg",
    "vol10DayAvg",
    "vol3MonthAvg",
]
db_cols = [f.lower() for f in fields]


def fundamentals(auth: TDAuth, symbol: str):
    resp = requests.get(
        url="https://api.tdameritrade.com/v1/instruments",
        params={
            "apikey": auth.client_id,
            "symbol": symbol,
            "projection": "fundamental",
        },
        headers=auth.auth_header,
    )
    print(f"Status: {resp.status_code}")
    if resp.status_code == 429:
        sleep(5)
        return fundamentals(auth, symbol)
    if resp.status_code == 200:
        data = resp.json()
        values = list(data.values())
        assert len(values) == 1
        data = values.pop()
        # convert nested dict to flat dict.
        data.update(data.pop("fundamental"))
        return data
