# Import the client
import asyncio

import numpy as np
import pandas as pd
from td.client import TDClient


def test_stream():
    import os

    # Create a new session, credentials path is required.
    TDSession = TDClient(
        client_id="HVMXCQ891SQLELVNUS7R3JTWUHKBTHAT",
        account_ids=[],
        refresh_token=,
        redirect_uri="http://127.0.0.1",
        credentials_path="/home/dan/danklabs/fin-data/fin_data/sources/td_ameritrade/td_auth.json",
    )
    # Login to the session.
    TDSession.login()

    # Create a streaming session.
    td_client = TDSession.create_streaming_session()

    # Account Activity.
    td_client.account_activity()

    # Quality of Service.
    td_client.quality_of_service(qos_level="express")

    td_client.level_two_options(
        symbols=["SPY", "TSLA", "VXX", "QQQ"], fields=["0", "1", "2"]
    )

    td_client.level_one_options(
        symbols=["SPY", "TSLA", "VXX", "QQQ"], fields=[str(i) for i in range(41)]
    )

    async def main(df_rows=1_000_000):
        df = pd.DataFrame(np.zeros((df_rows, 10)))
        # get websocket connection.
        conn = await td_client.build_pipeline()
        while True:
            for i in range(df_rows):
                msg = await conn.recv()
                msg = await td_client._parse_json_message(message=msg)
                print(msg)

    asyncio.run(main())


async def main():

    auth = TDAuth.from_gcs_env()

    request = {
        "service": "LEVELONE_FUTURES",
        "command": "SUBS",
        "parameters": {
            "keys": "/ES",
            # Subscribe to Bid Price, Ask Price, Last Price, Bid Size.
            "fields": "0,1,2,3,4",
        },
    }
    # get a logged in and authenticated websocket connection.
    conn = await auth.get_stream_websocket()
    # connect to stream
    request = auth.authenticate_stream_requests(request)
    await conn.send(request)
    # receive stream data forever.
    while True:
        message = await conn.recv()
        message_decoded = json.loads(message)
        print(message_decoded)


if __name__ == "__main__":
    