import sqlalchemy as sa

metadata = sa.MetaData(schema="yahoo_finance")

quotes_table = sa.Table(
    "yahoo_quotes",
    metadata,
    sa.Column("symbol", sa.String, primary_key=True),
    sa.Column("time", sa.DateTime(timezone=False), primary_key=True),
    sa.Column("open", sa.Float),
    sa.Column("high", sa.Float),
    sa.Column("low", sa.Float),
    sa.Column("close", sa.Float),
    sa.Column("volume", sa.Integer),
)

dividends_table = sa.Table(
    "yahoo_dividends",
    metadata,
    sa.Column("symbol", sa.String, primary_key=True),
    sa.Column("datetime", sa.DateTime(timezone=False), primary_key=True),
    sa.Column("dividends", sa.Integer),
)


stock_splits_table = sa.Table(
    "yahoo_stock_splits",
    metadata,
    sa.Column("symbol", sa.String, primary_key=True),
    sa.Column("datetime", sa.DateTime(timezone=False), primary_key=True),
    sa.Column("stock_splits", sa.Integer),
)
