# -*- coding: utf-8 -*-
from setuptools import setup

packages = \
['fin_data',
 'fin_data.alerts',
 'fin_data.analysis',
 'fin_data.data',
 'fin_data.formatting',
 'fin_data.oneoffs',
 'fin_data.sources',
 'fin_data.sources.alphavantage',
 'fin_data.sources.linkedin',
 'fin_data.sources.nasdaq',
 'fin_data.sources.sec',
 'fin_data.sources.sec.data_lists',
 'fin_data.sources.sec.rss',
 'fin_data.sources.td_ameritrade',
 'fin_data.sources.td_ameritrade.options',
 'fin_data.sources.thinkorswim',
 'fin_data.sources.yahoo',
 'fin_data.tools']

package_data = \
{'': ['*'], 'fin_data': ['schedule/*'], 'fin_data.sources.sec': ['systemd/*']}

install_requires = \
['aiohttp>=3.8.1,<4.0.0',
 'bokeh>=2.4.2,<3.0.0',
 'database-utils>=0.3.9,<0.4.0',
 'dominate>=2.6.0,<3.0.0',
 'dynamic-imports>=0.1.1,<0.2.0',
 'feedparser>=6.0.8,<7.0.0',
 'handcalcs>=1.4.1,<2.0.0',
 'host-throttle>=0.2.3,<0.3.0',
 'html-text>=0.5.2,<0.6.0',
 'lxml>=4.7.1,<5.0.0',
 'numpy>=1.22.1,<2.0.0',
 'pandas-profiling[notebook]>=3.1.0,<4.0.0',
 'pandas>=1.3.5,<2.0.0',
 'prefect>=2.0b2,<3.0',
 'psycopg2>=2.9.3,<3.0.0',
 'pydantic>=1.9.0,<2.0.0',
 'pytz>=2021.3,<2022.0',
 'ready-logger>=0.1.0,<0.2.0',
 'requests-cache>=0.9.1,<0.10.0',
 'requests>=2.27.1,<3.0.0',
 'td-ameritrade-python-api>=0.3.5,<0.4.0',
 'td-connect>=0.1.1,<0.2.0',
 'tqdm>=4.62.3,<5.0.0',
 'yfinance>=0.1.69,<0.2.0']

setup_kwargs = {
    'name': 'fin-data',
    'version': '0.1.2',
    'description': '',
    'long_description': None,
    'author': 'Dan Kelleher',
    'author_email': 'dan@danklabs.org',
    'maintainer': None,
    'maintainer_email': None,
    'url': None,
    'packages': packages,
    'package_data': package_data,
    'install_requires': install_requires,
    'python_requires': '>=3.9,<4.0',
}


setup(**setup_kwargs)
